/* List of valid keys */
    "ANY",		"KEY_ANY",
    "UNDERSCORE",	"'_'",
    "PLUS",		"'+'",
    "MINUS",		"'-'",
    "AT",		"'@'",
    "HASH",		"'#'",
    "DOLLAR",		"'$'",
    "SLASH",		"'/'",
    "ASTERISK",		"'*'",
    "TILDE",		"'~'",
    "BANG",		"'!'",
    "EQUAL",		"'='",
    "PERCENT",		"'%'",
    "AMPERSAND",	"'&'",
    "LPAR",		"'('",
    "RPAR",		"')'",
    "LBRACKET",		"'['",
    "RBRACKET",		"']'",
    "LBRACE",		"'{'",
    "RBRACE",		"'}'",
    "QUOTE",		"'\"'",
    "SPACE",		"' '", /* Space bar */
    "BLANK",		"' '", /* Space bar */
    "QUESTION",		"'?'", /* Question mark */
    "ESC",		"27", /* Escape */
    "BS",		"'\\b'", /* Backspace */
    "DEL",		"127", /* Delete */
    "CR",		"'\\n'", /* Carriage return */
    "TAB",		"'\t'", /* Tab */
    "BREAK",		"KEY_BREAK", /* break key (unreliable) */
    "DOWN",		"KEY_DOWN", /* Sent by terminal down arrow key */
    "UP",		"KEY_UP", /* Sent by terminal up arrow key */
    "LEFT",		"KEY_LEFT", /* Sent by terminal left arrow key */
    "RIGHT",		"KEY_RIGHT", /* Sent by terminal right arrow key */
    "HOME",		"KEY_HOME", /* Sent by home key. */
    "BACKSPACE",	"KEY_BACKSPACE", /* Sent by backspace key */
    "F0",		"KEY_F0", /* function key f0. */
    "F1",	        "(KEY_F0+(1))",
    "F2",	        "(KEY_F0+(2))",
    "F3",	        "(KEY_F0+(3))",
    "F4",	        "(KEY_F0+(4))",
    "F5",	        "(KEY_F0+(5))",
    "F6",	        "(KEY_F0+(6))",
    "F7",	        "(KEY_F0+(7))",
    "F8",	        "(KEY_F0+(8))",
    "F9",	        "(KEY_F0+(9))",
    "F10",	        "(KEY_F0+(10))",
    "F11",	        "(KEY_F0+(11))",
    "F12",	        "(KEY_F0+(12))",
    "F13",	        "(KEY_F0+(13))",
    "F14",	        "(KEY_F0+(14))",
    "F15",	        "(KEY_F0+(15))",
    "F16",	        "(KEY_F0+(16))",
    "F17",	        "(KEY_F0+(17))",
    "F18",	        "(KEY_F0+(18))",
    "F19",	        "(KEY_F0+(19))",
    "F20",	        "(KEY_F0+(20))",
    "DL",		"KEY_DL", /* Sent by delete line key. */
    "IL",		"KEY_IL", /* Sent by insert line. */
    "DC",		"KEY_DC", /* Sent by delete character key. */
    "IC",		"KEY_IC", /* Sent by ins char/enter ins mode key. */
    "EIC",		"KEY_EIC", /* Sent by rmir or smir in insert mode. */
    "CLEAR",		"KEY_CLEAR", /* Sent by clear screen or erase key. */
    "EOS",		"KEY_EOS", /* Sent by clear-to-end-of-screen key. */
    "EOL",		"KEY_EOL", /* Sent by clear-to-end-of-line key. */
    "SF",		"KEY_SF", /* Sent by scroll-forward/down key */
    "SR",		"KEY_SR", /* Sent by scroll-backward/up key */
    "NPAGE",		"KEY_NPAGE", /* Sent by next-page key */
    "PPAGE",		"KEY_PPAGE", /* Sent by previous-page key */
    "STAB",		"KEY_STAB", /* Sent by set-tab key */
    "CTAB",		"KEY_CTAB", /* Sent by clear-tab key */
    "CATAB",		"KEY_CATAB", /* Sent by clear-all-tabs key. */
    "ENTER",		"KEY_ENTER", /* Enter/send (unreliable) */
    "SRESET",		"KEY_SRESET", /* soft (partial) reset (unreliable) */
    "RESET",		"KEY_RESET", /* reset or hard reset (unreliable) */
    "PRINT",		"KEY_PRINT", /* print or copy */
    "LL",		"KEY_LL", /* Sent by home-down key */
					/* The keypad is arranged like this: */
					/*    a1    up    a3   */
					/*   left   b2  right  */
					/*    c1   down   c3   */
    "A1",		"KEY_A1", /* Upper left of keypad */
    "A3",		"KEY_A3", /* Upper right of keypad */
    "B2",		"KEY_B2", /* Center of keypad */
    "C1",		"KEY_C1", /* Lower left of keypad */
    "C3",		"KEY_C3", /* Lower right of keypad */
    "BTAB",		"KEY_BTAB", /* Back tab key */
    "BEG",		"KEY_BEG", /* beg(inning) key */
    "CANCEL",		"KEY_CANCEL", /* cancel key */
    "CLOSE",		"KEY_CLOSE", /* close key */
    "COMMAND",		"KEY_COMMAND", /* cmd (command) key */
    "COPY",		"KEY_COPY", /* copy key */
    "CREATE",		"KEY_CREATE", /* create key */
    "END",		"KEY_END", /* end key */
    "EXIT",		"KEY_EXIT", /* exit key */
    "FIND",		"KEY_FIND", /* find key */
    "HELP",		"KEY_HELP", /* help key */
    "MARK",		"KEY_MARK", /* mark key */
    "MESSAGE",		"KEY_MESSAGE", /* message key */
    "MOVE",		"KEY_MOVE", /* move key */
    "NEXT",		"KEY_NEXT", /* next object key */
    "OPEN",		"KEY_OPEN", /* open key */
    "OPTIONS",		"KEY_OPTIONS", /* options key */
    "PREVIOUS",	"KEY_PREVIOUS", /* previous object key */
    "REDO",		"KEY_REDO", /* redo key */
    "REFERENCE",	"KEY_REFERENCE", /* ref(erence) key */
    "REFRESH",		"KEY_REFRESH", /* refresh key */
    "REPLACE",		"KEY_REPLACE", /* replace key */
    "RESTART",		"KEY_RESTART", /* restart key */
    "RESUME",		"KEY_RESUME", /* resume key */
    "SAVE",		"KEY_SAVE", /* save key */
    "SBEG",		"KEY_SBEG", /* shifted beginning key */
    "SCANCEL",		"KEY_SCANCEL", /* shifted cancel key */
    "SCOMMAND",	"KEY_SCOMMAND", /* shifted command key */
    "SCOPY",		"KEY_SCOPY", /* shifted copy key */
    "SCREATE",		"KEY_SCREATE", /* shifted create key */
    "SDC",		"KEY_SDC", /* shifted delete char key */
    "SDL",		"KEY_SDL", /* shifted delete line key */
    "SELECT",		"KEY_SELECT", /* select key */
    "SEND",		"KEY_SEND", /* shifted end key */
    "SEOL",		"KEY_SEOL", /* shifted clear line key */
    "SEXIT",		"KEY_SEXIT", /* shifted exit key */
    "SFIND",		"KEY_SFIND", /* shifted find key */
    "SHELP",		"KEY_SHELP", /* shifted help key */
    "SHOME",		"KEY_SHOME", /* shifted home key */
    "SIC",		"KEY_SIC", /* shifted input key */
    "SLEFT",		"KEY_SLEFT", /* shifted left arrow key */
    "SMESSAGE",	"KEY_SMESSAGE", /* shifted message key */
    "SMOVE",		"KEY_SMOVE", /* shifted move key */
    "SNEXT",		"KEY_SNEXT", /* shifted next key */
    "SOPTIONS",	"KEY_SOPTIONS", /* shifted options key */
    "SPREVIOUS",	"KEY_SPREVIOUS", /* shifted prev key */
    "SPRINT",		"KEY_SPRINT", /* shifted print key */
    "SREDO",		"KEY_SREDO", /* shifted redo key */
    "SREPLACE",	"KEY_SREPLACE", /* shifted replace key */
    "SRIGHT",		"KEY_SRIGHT", /* shifted right arrow */
    "SRSUME",		"KEY_SRSUME", /* shifted resume key */
    "SSAVE",		"KEY_SSAVE", /* shifted save key */
    "SSUSPEND",	"KEY_SSUSPEND", /* shifted suspend key */
    "SUNDO",		"KEY_SUNDO", /* shifted undo key */
    "SUSPEND",		"KEY_SUSPEND", /* suspend key */
    "UNDO",		"KEY_UNDO", /* undo key */
    "MOUSE",		"KEY_MOUSE", /* Mouse event has occured */
    "AA",		"'A'", /* key A */
    "BB",		"'B'", /* key B */
    "CC",		"'C'", /* key C */
    "DD",		"'D'", /* key D */
    "EE",		"'E'", /* key E */
    "FF",		"'F'", /* key F */
    "GG",		"'G'", /* key G */
    "HH",		"'H'", /* key H */
    "II",		"'I'", /* key I */
    "JJ",		"'J'", /* key J */
    "KK",		"'K'", /* key K */
    "LL",		"'L'", /* key L */
    "MM",		"'M'", /* key M */
    "NN",		"'N'", /* key N */
    "OO",		"'O'", /* key O */
    "PP",		"'P'", /* key P */
    "QQ",		"'Q'", /* key Q */
    "RR",		"'R'", /* key R */
    "SS",		"'S'", /* key S */
    "TT",		"'T'", /* key T */
    "UU",		"'U'", /* key U */
    "VV",		"'V'", /* key V */
    "WW",		"'W'", /* key W */
    "XX",		"'X'", /* key X */
    "YY",		"'Y'", /* key Y */
    "ZZ",		"'Z'", /* key Z */
    "a",		"'a'", /* key a */
    "b",		"'b'", /* key b */
    "c",		"'c'", /* key c */
    "d",		"'d'", /* key d */
    "e",		"'e'", /* key e */
    "f",		"'f'", /* key f */
    "g",		"'g'", /* key g */
    "h",		"'h'", /* key h */
    "i",		"'i'", /* key i */
    "j",		"'j'", /* key j */
    "k",		"'k'", /* key k */
    "l",		"'l'", /* key l */
    "m",		"'m'", /* key m */
    "n",		"'n'", /* key n */
    "o",		"'o'", /* key o */
    "p",		"'p'", /* key p */
    "q",		"'q'", /* key q */
    "r",		"'r'", /* key r */
    "s",		"'s'", /* key s */
    "t",		"'t'", /* key t */
    "u",		"'u'", /* key u */
    "v",		"'v'", /* key v */
    "w",		"'w'", /* key w */
    "x",		"'x'", /* key x */
    "y",		"'y'", /* key y */
    "z",		"'z'", /* key z */
