/*=========================================================================

	ATOC main header file

=========================================================================*/

#define VERSION		"v1.08"

#define TRUE		1
#define FALSE		0
#define PRIVATE		static

#define MAXLINELENGTH	1024

#if 'A' == 0x41
 #define ASCII
#endif
#if 'A' == 0xC1
 #define EBCDIC
#endif


/*-------------------------------------------------------------------------
global variables
-------------------------------------------------------------------------*/
#ifdef MAIN_MODULE
 #define GLOBAL
#else
 #define GLOBAL extern
#endif

GLOBAL int exitcode;			/* ATOC exit code */

GLOBAL int enumflag;			/* convert enums */
GLOBAL int includeflag;			/* include include files */
GLOBAL int localonlyflag;		/* include local include files only */
GLOBAL int trigraphflag;		/* convert trigraphs */
GLOBAL int voidflag;			/* convert voids */

GLOBAL int linenumber;			/* source file line number */
GLOBAL char filename[ 80 ];		/* source file name "filename" */
GLOBAL char compiledate[ 16 ];		/* compile date "Mmm dd yyyy" */
GLOBAL char compiletime[ 16 ];		/* compile time "hh:mm:ss" */

GLOBAL char buffer[ MAXLINELENGTH ];	/* input line buffer */

GLOBAL int decflag;			/* TRUE when there are declarations */
					/* waiting to be output */

GLOBAL int endifcount;			/* count of #endifs waiting to be output */

/*=======================================================================*/
