#define	CURSES_LIBRARY	1
#include <curses.h>

#ifndef	NDEBUG
char *rcsid_shadow = "$Header: k:/tools/src/curses/nonport/rcs/shadow.c 2.1.0.2 93/08/13 08:41:05 frotz Beta2 $";
#endif

/*man-start*********************************************************************

  shadow()	- Specify light source for a window shadow

  PDCurses Description:
 	Specifies the light source direction for a specified window.
 	This light source is opposite of the shadow being cast.
 
 	Light Source Directions:
 	------------------------
 
 			NORTH
 	    NORTH_WEST	  1    NORTH_EAST
 		      8   |   2
 		       \  |  /
 			\ | /
 	       WEST 7 ---\./---3 EAST
 			 /|\
 			/ | \
 		       6  |  4
 	     SOUTH_WEST   5   SOUTH_EAST
 			SOUTH
 
 	If there is no shadowing, specify a light source of 0.
	This routine is implemented as a macro.

  PDCurses Return Value:
 	The shadow() function returns the specified direction.

  PDCurses Errors:
 	No errors are defined for this function.

  Portability:
 	PDCurses	int shadow( WINDOW* win, int light_src_dir, chtype chattr );
 	BSD Curses
 	SYS V Curses

**man-end**********************************************************************/

int	shadow( WINDOW* win, int light_src_dir, chtype chattr )
{
#ifdef PDCDEBUG
	if (trace_on) PDC_debug("shadow() - called\n");
#endif

	if (win == (WINDOW *)NULL)
		return( ERR );

	win->_shadow	  = light_src_dir;
	win->_shadow_char = chattr;
	return( OK );
}



