#define	CURSES_LIBRARY	1
#include <curses.h>

#ifndef	NDEBUG
char *rcsid_shadows = "$Header: k:/tools/src/curses/nonport/rcs/shadows.c 2.1.0.2 93/08/13 08:41:05 frotz Beta2 $";
#endif

/*man-start*********************************************************************

  shadows()	- Specify light source for window shadows

  PDCurses Description:
 	Specifies the default light source direction for shadows on all windows.
 	The light source is opposite of the shadow being cast.
 
 	Light Source Directions:
 	------------------------
 
 			NORTH
 	    NORTH_WEST	  1    NORTH_EAST
 		      8   |   2
 		       \  |  /
 			\ | /
 	       WEST 7 ---\./---3 EAST
 			 /|\
 			/ | \
 		       6  |  4
 	     SOUTH_WEST   5   SOUTH_EAST
 			SOUTH
 
 	If there is no shadowing, specify a light source of 0.
	This routine is implemented as a macro.

  PDCurses Return Value:
 	The shadows() function returns the specified direction.

  PDCurses Errors:
 	No errors are defined for this function.

  Portability:
 	PDCurses	int shadows( int light_src_dir, chtype chattr );
 	BSD Curses
 	SYS V Curses

**man-end**********************************************************************/

int	shadows( int light_src_dir, chtype chattr )
{
#ifdef PDCDEBUG
	if (trace_on) PDC_debug("shadow() - called\n");
#endif

	if (stdscr == (WINDOW *)NULL)
		return( ERR );

	_cursvar.shadows	= light_src_dir;
	_cursvar.shadow_char	= chattr;
	return( OK );
}



