#define	CURSES_LIBRARY	1
#include <curses.h>
#undef	box

#ifdef PDCDEBUG
char *rcsid_box = "$Header: C:\CURSES\portable\RCS\box.c 2.1 1993/06/18 20:19:37 MH Rel MH $";
#endif




/*man-start*********************************************************************

  box()	- draw box

  X/Open Description:	
 	A box is drawn around the edge of the window.  The characters
 	vert and hor are the characters used to draw the box.  If vert or
 	hor are zero, then appropriate default characters will be used.

  PDCurses Description:
 	See border() for additional control over the sides and corners
 	of the box drawn.

  X/Open Return Value:
 	The box() function returns OK on success and ERR on error.

  PDCurses Errors:
 	No errors are defined for these functions.

  Portability:
 	PDCurses	int box( WINDOW* win, chtype vert, chtype hor );
 	X/Open Dec '88	int box( WINDOW* win, chtype vert, chtype hor );
 	BSD Curses	int box( WINDOW* win, chtype vert, chtype hor );
 	SYS V Curses	int box( WINDOW* win, chtype vert, chtype hor );

**man-end**********************************************************************/

int	box( WINDOW *win, chtype vert, chtype hor )
{
#ifdef PDCDEBUG
	if (trace_on) PDC_debug("box() - called\n");
#endif

	if  (!vert || !hor)
	{			/* SYSV Fix Courtesy of Augustine Cano */
		vert= ACS_VLINE;/* afc@shibaya.lonestar.org */
		hor = ACS_HLINE;/* 19920520           */
	}
	return( wbox( win, 0, 0, 0, 0, vert, hor ) );
}
