#define	CURSES_LIBRARY	1
#include <curses.h>
#ifdef UNIX
#include <defs.h>
#include <term.h>
#endif
#undef can_change_color

#ifdef PDCDEBUG
char *rcsid_canchang = "$Header: C:\CURSES\portable\RCS\canchang.c 2.1 1993/06/18 20:19:39 MH Rel MH $";
#endif




/*man-start*********************************************************************

  can_change_color()	- Indicate if terminal can change color definitions

  PDCurses Description:
 	This is defined as a macro.

 	This routine indicates if the terminal has the capability to change
 	the definition of its colors. Although this is possible at least
 	with VGA monitors, this function always returns FALSE.


  PDCurses Return Value:
 	This function returns FALSE.

  PDCurses Errors:
 	N/A

  Portability:
 	PDCurses	int can_change_color( void );

**man-end**********************************************************************/

int can_change_color(void)
{
#ifdef PDCDEBUG
	if (trace_on) PDC_debug("can_change_color() - called\n");
#endif

#ifdef UNIX
	if (can_change)
		return(TRUE);
	else
		return(FALSE);
#else
	return(FALSE);
#endif
}
