#define	CURSES_LIBRARY	1
#include <curses.h>
#undef	clearok

#ifdef PDCDEBUG
char *rcsid_clearok = "$Header: C:\CURSES\portable\RCS\clearok.c 2.1 1993/06/18 20:19:42 MH Rel MH $";
#endif




/*man-start*********************************************************************

  clearok()	- enable screen clearing

  X/Open Description:
 	If bf is TRUE, the next call to wrefresh() with this window will
 	clear the screen completely and redraw the entire screen.

  X/Open Return Value:
 	The clearok() function returns OK on success and ERR on error.

  X/Open Errors:
 	No errors are defined for this function.

  PDCurses Errors:
 	It is an error to call this function with a NULL window pointer.

  Portability:
 	PDCurses	int clearok( WINDOW* win, bool flag );
 	X/Open Dec '88	int clearok( WINDOW* win, bool bf );
 	BSD Curses
 	SYS V Curses	int clearok( WINDOW* win, bool bf );

**man-end**********************************************************************/

int	clearok(WINDOW *win, bool flag)
{
#ifdef PDCDEBUG
	if (trace_on) PDC_debug("clearok() - called\n");
#endif

	if (win == (WINDOW *)NULL)
		return( ERR );

	win->_clear = flag;

	return( OK );
}
