#ifndef NO_MEMORY_H
#include <memory.h>
#endif
#define	CURSES_LIBRARY	1
#include <curses.h>
#undef	def_shell_mode

#ifdef PDCDEBUG
char *rcsid_def_shel = "$Header: C:\CURSES\portable\RCS\def_shel.c 2.1 1993/06/18 20:19:45 MH Rel MH $";
#endif


#ifndef UNIX

/*man-start*********************************************************************

  def_shell_mode()	- Save terminal mode

  X/Open Description:
 	Save the current terminal modes as the "program" (in CURSES) or
 	"shell" (not in CURSES) state for use by the reset_prog_mode()
 	and reset_shell_mode() functions.  This is done automatically by
 	initscr().

  PDCurses Description:
 	PDCurses maintains a WINDOW* that contains the original user's
 	screen upon startup.  This might be useful for returning the
 	user's environment to its (near) original state.

 	This is unimplemented at this time.

  X/Open Return Value:
 	The def_shell_mode() function returns OK on success and ERR on error.

  X/Open Errors:
 	No errors are defined for this function.

  Portability:
 	PDCurses	int def_shell_mode( void );
 	X/Open Dec '88	int def_shell_mode( void );
 	BSD Curses
 	SYS V Curses	int def_shell_mode( void );

**man-end**********************************************************************/

int	def_shell_mode(void)
{
#ifdef PDCDEBUG
	if (trace_on) PDC_debug("def_shell_mode() - called\n");
#endif

#ifdef	FLEXOS
	_flexos_8bitmode();
#endif
	c_sh_tty.been_set = TRUE;

	memcpy(&c_sh_tty.saved, &_cursvar, sizeof(SCREEN));

	return( OK );
}
#endif
