#define	CURSES_LIBRARY	1
#include <curses.h>

#ifdef UNIX
#define NOTLIB
#include <defs.h>
#include <term.h>
#endif
#undef	erasechar

#ifdef PDCDEBUG
char *rcsid_erasecha = "$Header: C:\CURSES\portable\RCS\erasecha.c 2.1 1993/06/18 20:19:14 MH Rel MH $";
#endif




/*man-start*********************************************************************

  erasechar()	- Return current ERASE character.

  X/Open Description:
 	The user's current ERASE character is returned.

  PDCurses Description:
 	This is hardcoded at this time.  There may be future development
 	to allow applications an easy way to specify this value.

  X/Open Return Value:
 	The erasechar() function returns the user's current line ERASE
 	character.

  X/Open Errors:
 	No errors are defined for this function.

  Portability:
 	PDCurses	char erasechar( void );
 	X/Open Dec '88	char erasechar( void );
 	BSD Curses	char erasechar( void );
 	SYS V Curses	char erasechar( void );
 	
**man-end**********************************************************************/

char	erasechar(void)
{
#ifdef PDCDEBUG
	if (trace_on) PDC_debug("erasechar() - called\n");
#endif

#ifdef UNIX
#ifdef USE_TERMIO
	ioctl(_CUR_TERM.fd, TCGETA, &_CUR_TERM.prog_mode);
	return(_CUR_TERM.prog_mode.c_cc[VERASE]);
#else
	ioctl(_CUR_TERM.fd, TIOCGETP, &_CUR_TERM.prog_mode.v6);
	return(_CUR_TERM.prog_mode.v6.sg_erase);
#endif
#else
	return(	_ECHAR );	/* character delete char (^H) */
#endif
}
