#define	CURSES_LIBRARY	1
#include <curses.h>
#undef	getyx

#ifdef PDCDEBUG
char *rcsid_getyx = "$Header: C:\CURSES\portable\RCS\getyx.c 2.1 1993/06/18 20:19:59 MH Rel MH $";
#endif




/*man-start*********************************************************************

  getyx()	- get cursor position

  X/Open Description:
 	The cursor position of the window is placed in the two integer
 	variables y and x.  This is implemented as a macro, so no & is
 	necessary before the variables.

 	NOTE: getyx() is a macro.

  PDCurses Description:
 	This routine is here to as a documentation place holder.  The
 	code in this module will never be executed unless you #undef
 	getyx(), in which case, you will need the & operator.

  X/Open Return Value:
 	This function returns OK on success and ERR on error.

  X/Open Errors:
 	No errors are defined for this function.

  Portability:
 	PDCurses	int getyx( WINDOW* win, int* y, int* x );
 	    or 		int getyx( WINDOW* win, int y, int x );
 	X/Open Dec '88	int getyx( WINDOW* win, int y, int x );
 	BSD Curses	int getyx( WINDOW* win, int y, int x );
 	SYS V Curses	int getyx( WINDOW* win, int y, int x );

**man-end**********************************************************************/

int	getyx( WINDOW *win, int *y, int *x )
{
#ifdef PDCDEBUG
	if (trace_on) PDC_debug("getyx() - called\n");
#endif

	*y = win->_cury;
	*x = win->_curx;
	return( OK );
}
