#define	CURSES_LIBRARY	1
#include <curses.h>
#ifdef UNIX
#include <defs.h>
#include <term.h>
#endif
#undef	has_ic

#ifdef PDCDEBUG
char *rcsid_has_ic = "$Header: C:\CURSES\portable\RCS\has_ic.c 2.1 1993/06/18 20:20:02 MH Rel MH $";
#endif




/*man-start*********************************************************************

  has_ic()	- determine whether insert/delete character available

  X/Open Description:
 	This function will return TRUE if the terminal has insert character
 	and delete character capabilities.

  PDCurses Description:
 	For DOS, this is irrelevant (and ALWAYS TRUE), as the speed of
 	the DIRECT VIDEO or even BIOS writes is quicker than on a
 	serial terminal.

 	For FLEXOS, this value has meaning and depends on the terminal,
 	though at this time, it is a constant TRUE.

  X/Open Return Value:
 	The has_ic() function returns TRUE if the terminal has insert
 	character and delete character capabilities, otherwise it returns
 	FALSE.

  X/Open Errors:
 	No errors are defined for this function.

  Portability:
 	PDCurses	bool has_ic(void);
 	X/Open Dec '88	bool has_ic(void);
 	BSD Curses	
 	SYS V Curses	

**man-end**********************************************************************/

bool	has_ic(void)
{
#ifdef PDCDEBUG
	if (trace_on) PDC_debug("has_ic() - called\n");
#endif

#ifdef UNIX
	if (insert_character != NULL && delete_character != NULL)
		return(TRUE);
	else
		return(FALSE);
#else
	return( TRUE );
#endif
}
