#define	CURSES_LIBRARY	1
#include <curses.h>
#ifdef UNIX
#include <defs.h>
#include <term.h>
#endif
#undef	has_il

#ifdef PDCDEBUG
char *rcsid_has_il = "$Header: C:\CURSES\portable\RCS\has_il.c 2.1 1993/06/18 20:20:04 MH Rel MH $";
#endif




/*man-start*********************************************************************

  has_il()	- determine whether insert/delete line available

  X/Open Description:
 	This function will return TRUE if the terminal has insert line
 	and delete line capabilities.

  PDCurses Description:
 	For DOS, this is irrelevant (and ALWAYS TRUE), as the speed of
 	the DIRECT VIDEO or even BIOS writes is quicker than on a
 	serial terminal.

 	For FLEXOS, this value has meaning and depends on the terminal,
 	though at this time, it is a constant TRUE.

  X/Open Return Value:
 	The has_il() function returns TRUE if the terminal has insert
 	line and delete line capabilities, otherwise it returns
 	FALSE.

  X/Open Errors:
 	No errors are defined for this function.

  Portability:
 	PDCurses	bool has_il( void );
 	X/Open Dec '88	bool has_il( void );
 	BSD Curses	
 	SYS V Curses	

**man-end**********************************************************************/

bool	has_il(void)
{
#ifdef PDCDEBUG
	if (trace_on) PDC_debug("has_il() - called\n");
#endif

#ifdef UNIX
	if (insert_line != NULL && delete_line != NULL)
		return(TRUE);
	else
		return(FALSE);
#else
	return( TRUE );
#endif
}
