#define	CURSES_LIBRARY	1
#include <curses.h>
#undef	idlok

#ifdef PDCDEBUG
char *rcsid_idlok = "$Header: C:\CURSES\portable\RCS\idlok.c 2.1 1993/06/18 20:20:06 MH Rel MH $";
#endif




/*man-start*********************************************************************

  idlok()	- Enable use of Insert/Delete Line

  X/Open Description:
 	If enabeld (bf is TRUE), curses will use the insert/delete line
 	feature of terminals so equipped.  If disabled, curses will not
 	use this feature.  (The insert/delete character feature is always
 	used.)  This option should be enabled only if the application
 	needs insert/delete line; for example, for a screen editor.  It
 	is disabled by default because insert/delete line tends to be
 	visually annoying when used in applications where it isn't really
 	needed.  If insert/delete line cannot be used, curses will redraw
 	the changed portions of all lines.

  PDCurses Description:
 	This is provided for portability.  This may have some value for
 	the FLEXOS platform, but there is no code in PDCurses at this
 	time (910725) that takes advantage of this.

  X/Open Return Value:
 	The idlok() function returns OK on success and ERR on error.

  X/Open Errors:
 	No errors are defined for this function.

  Portability:
 	PDCurses	int idlok( WINDOW* win, bool bf );
 	X/Open Dec '88	int idlok( WINDOW* win, bool bf );
 	BSD Curses	
 	SYS V Curses	

**man-end**********************************************************************/

int	idlok( WINDOW *win, bool bf )
{
#ifdef PDCDEBUG
	if (trace_on) PDC_debug("idlok() - called\n");
#endif

	win->_use_idl = bf;
	return( OK );
}
