#define	CURSES_LIBRARY	1
#include <curses.h>
#undef	mvwin

#ifdef PDCDEBUG
char *rcsid_mvwin = "$Header: C:\CURSES\portable\RCS\mvwin.c 2.1 1993/06/18 20:20:24 MH Rel MH $";
#endif




/*man-start*********************************************************************

  mvwin()	- move window

  X/Open Description:
 	

  PDCurses Description:
 	There is no additional PDCurses functionality.

  X/Open Return Value:
 	The mvwin() routine returns OK on success and otherwise ERR
 	is returned.

  PDCurses Errors:
 	It is an error to call this function with a NULL window pointer.
 	It is also an error to address a position that is outside the
 	bounds of the specified window.

  Portability:
 	PDCurses	int mvwin( WINDOW* win, int y, int x );
 	X/Open Dec '88	int mvwin( WINDOW* win, int y, int x );
 	BSD Curses	int mvwin( WINDOW* win, int y, int x );
 	SYS V Curses	int mvwin( WINDOW* win, int y, int x );

**man-end**********************************************************************/

int	mvwin(WINDOW *win, int y, int x)
{
#ifdef PDCDEBUG
	if (trace_on) PDC_debug("mvwin() - called\n");
#endif

	if (win == (WINDOW *)NULL)
		return( ERR );

	if (win->_begy + win->_maxy > LINES)
		return( ERR );

	if (win->_begx + win->_maxx > COLS)
		return( ERR );

	win->_begy = y;
	win->_begx = x;
	touchwin(win);
	return( OK );
}
