#define	CURSES_LIBRARY	1
#include <curses.h>
#undef	nodelay

#ifdef PDCDEBUG
char *rcsid_nodelay = "$Header: C:\CURSES\portable\RCS\nodelay.c 2.1 1993/06/18 20:20:37 MH Rel MH $";
#endif




/*man-start*********************************************************************

  nodelay()	- disable block during read

  X/Open Description:
 	This function controls whether wgetch() is a non-blocking
 	call. If the option is enabled, and no input is ready, wgetch()
 	will return ERR. If disabled, wgetch() will hang until input
 	is ready.

  PDCurses Description:
 	There is no additional PDCurses functionality for this function.

  X/Open Return Value:
 	This function returns OK on success and ERR on error.

  X/Open Errors:
 	No errors are defined for this function.

  Portability:
 	PDCurses	int nodelay( WINDOW* win, bool bf );
 	X/Open Dec '88	int nodelay( WINDOW* win, bool bf );
 	BSD Curses	int nodelay( WINDOW* win, bool bf );
 	SYS V Curses	int nodelay( WINDOW* win, bool bf );

**man-end**********************************************************************/

int	nodelay( WINDOW *win, bool flag )
{
#ifdef PDCDEBUG
	if (trace_on) PDC_debug("nodelay() - called\n");
#endif

	win->_nodelay = flag;
	return( OK );
}
