#define	CURSES_LIBRARY	1
#include <curses.h>
#undef	set_term

#ifdef PDCDEBUG
char *rcsid_set_term = "$Header: C:\CURSES\portable\RCS\set_term.c 2.1 1993/06/18 20:21:10 MH Rel MH $";
#endif

#if	EMALLOC
void*	emalloc( size_t );
void*	ecalloc( size_t, size_t );
void	efree( void* );
#endif





/*man-start*********************************************************************

  set_term()	- switch between terminals

  X/Open Description:
 	This function is used to switch between different terminals.
 	The screen reference 'new' becomes the new current terminal.
 	The previous terminal is returned by the routine.  This is the
 	only routine which manipulates SCREEN pointers; all other routines
 	affect only the current terminal.

  PDCurses Description:
 	FYI: Dual monitor support is not quite complete.  Nothing will
 	happen if you try to call this routine.

  X/Open Return Value:
 	The set_term() function returns a pointer to the previous
 	SCREEN structure on success otherwise a NULL pointer is
 	returned.

  X/Open Errors:
 	No errors are defined for this function.

  PDCurses Errors:
 	It is an error to call this routine at this time.
 	It is an error to pass a NULL SCREEN pointer.

  Portability:
 	PDCurses	SCREEN* set_term( SCREEN* new );
 	X/Open Dec '88	SCREEN* set_term( SCREEN* new );
 	BSD Curses	
 	SYS V Curses	SCREEN* set_term( SCREEN* new );

**man-end**********************************************************************/

SCREEN*	set_term( SCREEN *new )
{
#ifdef PDCDEBUG
	if (trace_on) PDC_debug("set_term() - called\n");
#endif

#ifdef	TC
#  pragma argsused
#endif
	return( &_cursvar );  /* We only have one screen supported right now */
}
