#define	CURSES_LIBRARY	1
#include <curses.h>
#undef	winch

#ifdef PDCDEBUG
char *rcsid_winch = "$Header: C:\CURSES\portable\RCS\winch.c 2.1 1993/06/18 20:21:40 MH Rel MH $";
#endif




/*man-start*********************************************************************

  winch()	- return character from window

  X/Open Description:
 	The character at the current position in the named window is
 	returned.  If any attributes are set for that position, their
 	values will be bitwise-OR'ed into the value returned.  The
 	pre-defined constants A_CHARTEXT and A_ATTRIBUTES, defined in
 	<curses.h>, can be used with the & (bitwise-AND) operator to
 	extract the character or attribute alone.

 	NOTE: inch(), winch(), mvinch() and mvwinch() are macros.

  PDCurses Description:
 	There is no additional PDCurses functionality.  This routine
 	is here as a documentation placeholder.  No code will be
 	executed in this module, unless the user #undefs winch.

  X/Open Return Value:
 	Upon successfull completion, the inch(), mvinch(), mvwinch(),
 	and winch() functions return the character at the selected
 	position.  Otherwise, the mvinch() and mvwinch() functions
 	return ERR.

  PDCurses Errors:
 	It is an error to call this function with a NULL window pointer.
 	It is also an error to address a position that is outside the
 	bounds of the specified window.

  Portability:
 	PDCurses	chtype winch( WINDOW* win );
 	X/Open Dec '88	chtype winch( WINDOW* win );
 	BSD Curses	
 	SYS V Curses	int winch( WINDOW* win );

**man-end**********************************************************************/

chtype	winch(WINDOW *win)
{
#ifdef PDCDEBUG
	if (trace_on) PDC_debug("winch() - called\n");
#endif

	return( win->_y[win->_cury][win->_curx] );
}
