#ifndef   _H_HASH_TABLE
#define   _H_HASH_TABLE

#ifndef lint
static const char hash_table_sccs_id[]="%W% %G% %U%: Component-%Y% %Q% ";
#endif

#include   "cpp_entry.h"
#include   "LinkedList.h"

const   int    HASH_TABLE_SIZE = 256 ;

const   int    NO_LOCK_IMPL = 2 ;
const   int    KERNEL_LOCK_IMPL = 3 ;

template <class K, class V, int sz >
class    HashTable ;

template  < class K, class V >
class  HashElement : public virtual CLASS
{
 public :
    HashElement( K& key_val, V& val ) : key(key_val), value(val) { } ;
    HashElement( K& kee ) : key(kee) { } ;
    ~HashElement() { } ;
    V&   get_val(void) { return value; }
    int  operator == (K &k) { return ( key == k ) ; } ;
    RTTI_SCAFFOLDING_DECL_TEMPL_2(HashElement,K,V)

 private :
    K key ;
    V value ;
} ; // specification for each hash element


template  < class K, class V, int sz >
class   HashTable : public virtual CLASS
{
  public :
     HashTable()  ;
     ~HashTable() ;
     V&    operator[] (K & ) ;
     void  remove (K &) ;
    RTTI_SCAFFOLDING_DECL_TEMPL_3(HashTable,K,V,sz)

  private :
     LinkedList< HashElement<K,V> >   table[sz] ;
     ListIterator< HashElement<K,V> >  *iter_ptrs[sz] ;
     HashElement<K,V> *find(K &, unsigned &) ;

} ; // specification for the hash table class

#endif //    _H_HASH_TABLE
