#ifndef     _H_LIST_IMPL_DBLOCK
#define     _H_LIST_IMPL_DBLOCK

#ifndef    lint
static const char list_impl_dblock_sccsid[]="%W% %G% %U%:Component-%Y% %Q%";
#endif   //  lint

#include   "Listconsts.h"
#include   "ListImplSpec.h"
#include   "ListImpl.h"
#include   "ListImplDouble.h"

// The mata-object for Doubly-Linked locked lists. It just instantiates
// an object of the DoublyLinkedLocked type
class  DoublyLinkLockMeta :  public ListMeta
{
public :
    DoublyLinkLockMeta ()  ;
    CLASS *instantiate(ImplSpec *);
    ~DoublyLinkLockMeta ( ) ;
    RTTI_SCAFFOLDING_DECL(DoublyLinkLockMeta)
private :
    static  int count ; // count to ensure that initialization is properly
			// done.
} ; // specifcation for the meta-object for the Doubly linked lock list

// The meta-object for iterators for doubly linked lists - contains the
// the constructors and destructors that register and unregister the
// type. The overloaded instantiate functiona that allow for the
// different types of constructors are alo defined herein.
class  DoublyLinkLockIterMeta : public IterMeta
{
public :
    DoublyLinkLockIterMeta ()  ;
    ListIterAncestor *instantiate(ImplSpec *, ListImplAncestor *);
    ListIterAncestor *instantiate(ImplSpec *, ListImplAncestor &);
    ~DoublyLinkLockIterMeta ( ) ;
     RTTI_SCAFFOLDING_DECL(DoublyLinkLockIterMeta)
private :
    static  int count ; // count to ensure that initialization is properly
			// done.
} ; // spec. for the meta-object for the Doubly linked lock list iter.

// The specification for the doubly linked implementation of linked lists.
class   DoublyLinkLockImpl : public DoublyLinkedImpl
{
 public :
     DoublyLinkLockImpl() ;

     virtual ~DoublyLinkLockImpl() { }  ;

     virtual void *remove_specific_elem(void *)  ;
     virtual ListImplAncestor *merge_lists(ListImplAncestor *,
						    ListElemPriority );
     virtual void queue ( void *, ListElemPriority ) ;
     virtual void *dequeue( void )  ;
     RTTI_SCAFFOLDING_DECL(DoublyLinkLockImpl)

     static  DoublyLinkLockMeta   *meta ;
private :
     int                 list_lock ;
} ; // the spcification for the doubly linked list

class   DoublyLinkLockIter :  public   DoublyLinkedIter
{
 public :
  DoublyLinkLockIter(ListImplAncestor *x) : DoublyLinkedIter(x) { }  ;
  DoublyLinkLockIter(ListImplAncestor &x) : DoublyLinkedIter(x) { } ;
  virtual ~DoublyLinkLockIter() { }  ;
  virtual void  reset(void) { DoublyLinkedIter::reset(); }  ;
  virtual void *operator() () { return (DoublyLinkedIter::operator()()); } ;
  RTTI_SCAFFOLDING_DECL(DoublyLinkLockIter)
  static  DoublyLinkLockIterMeta   *meta ;
} ;

#endif   // _H_LIST_IMPL_DBLOCK

