#ifndef     _H_LIST_IMPL_DOUBLE
#define     _H_LIST_IMPL_DOUBLE

#ifndef    lint
static const char list_impl_double_sccsid[]="%W% %G% %U%:Component-%Y% %Q%";
#endif   //  lint

#include   "Listconsts.h"
#include   "ListImplSpec.h"
#include   "ListImpl.h"

// The meta-object for Doubly linked lists - contains constructors and
// destructors that register and unregister. The instantiate function
// creates the linked list.
class  DoublyLinkedMeta :  public ListMeta
{
public :
    DoublyLinkedMeta ()  ;
    CLASS *instantiate(ImplSpec *);
    ~DoublyLinkedMeta ( ) ;
     RTTI_SCAFFOLDING_DECL(DoublyLinkedMeta)
private :
    static  int count ; // count to ensure that initialization is properly
			// done.
} ; // specifcation for the meta-object for the Doubly linked list

// The meta-object for iterators for doubly linked lists - contains the
// the constructors and destructors that register and unregister the
// type. The overloaded instantiate functiona that allow for the
// different types of constructors are alo defined herein.
class  DoublyLinkedIterMeta : public IterMeta
{
public :
    DoublyLinkedIterMeta ()  ;
    ListIterAncestor *instantiate(ImplSpec *, ListImplAncestor *);
    ListIterAncestor *instantiate(ImplSpec *, ListImplAncestor &);
    ~DoublyLinkedIterMeta ( ) ;
     RTTI_SCAFFOLDING_DECL(DoublyLinkedIterMeta)
private :
    static  int count ; // count to ensure that initialization is properly
			// done.
} ; // specifcation for the meta-object for the Doubly linked list iter.

class   DoubleNode : public virtual CLASS
  {
   public :
      DoubleNode(void *e = NULL) ;
      ~DoubleNode() ;
       void linkafter(DoubleNode *) ;
       void linkbefore(DoubleNode *) ;
       void *unlink(void) ;
       DoubleNode *get_next() { return next; }
       DoubleNode *get_prev() { return prev; }
       void *get_elem() { return elem; }
       RTTI_SCAFFOLDING_DECL(DoubleNode)

   private :
       void *elem ;
       DoubleNode   *prev , *next ;
       DoubleNode(const DoubleNode& ) { } ; // hide it
       void  do_link(DoubleNode *, DoubleNode *) ;
  } ; // specification for the Node class for doubly linked lists

// The specification for the doubly linked implementation of linked lists.
class   DoublyLinkedImpl : public ListImplAncestor
{
   friend   class DoublyLinkedIter ; // make iter. a friend for performance

 public :
     DoublyLinkedImpl() : first(0), last(0)
       { };
     virtual ~DoublyLinkedImpl()
	  {   }
     virtual void *remove_specific_elem(void *)  ;
     virtual ListImplAncestor *merge_lists(ListImplAncestor *,
						    ListElemPriority );
     virtual void queue ( void *, ListElemPriority ) ;
     virtual void *dequeue( void )  ;
     RTTI_SCAFFOLDING_DECL(DoublyLinkedImpl)

     static  DoublyLinkedMeta   *meta ;
  private :
     DoubleNode    *first ;
     DoubleNode    *last  ;
     DoubleNode    *search_for_elem(void *) ;
} ; // the spcification for the doubly linked list

class   DoublyLinkedIter :  public   ListIterAncestor
{
 public :
    DoublyLinkedIter(ListImplAncestor *) ;
    DoublyLinkedIter(ListImplAncestor & ) ;
    ~DoublyLinkedIter() { }  ;
    virtual void  reset(void) ;
    virtual void  *operator() () ;
    RTTI_SCAFFOLDING_DECL(DoublyLinkedIter)
    static  DoublyLinkedIterMeta   *meta ;

 private :
   // private data

      DoublyLinkedImpl   *list ;
      DoubleNode         *current_node ;
} ;

#endif   // _H_LIST_IMPL_DOUBLE
