#ifndef lint
  static const char sccs_id[]= "%W% %G% %U%: Component-%Y% %Q%" ;
#endif

#include    "cpp_entry.h"
#include    "LinkedList.h"
#include    "HashTable.h"

TEMPL_RTTI_IMPL_SCAFF_1_2(HashElement,class K, class V,CLASS,K,V)

TEMPL_RTTI_IMPL_SCAFF_1_3(HashTable,class K, class V,int sz,CLASS,K,V,sz)

template < class K, class V, int sz >
HashTable< K, V, sz >::HashTable()
{
  for ( int i = 0 ; i != sz ; i++ )
    iter_ptrs[i] = new ListIterator< HashElement<K,V> > (table[i]) ;

} // constructor

template < class K, class V, int sz >
HashTable< K, V, sz >::~HashTable()
{
  for ( int i = 0 ; i != sz ; i++ )
    delete (iter_ptrs[i] )  ;

} // destructor


template < class K, class V, int sz >
HashElement< K,V > *HashTable< K, V, sz >::find( K &kee, unsigned &index)
{
  index = kee % sz ;
  ListIterator< HashElement<K,V> >   *iter = iter_ptrs[index]  ;
  HashElement< K, V >   *elem ;
  iter->reset() ;


  while ( elem = (*iter)() )
   {
     if ( *elem ==  kee )
       return ( elem ) ;
   } // loop thru and look for the element

  return ( NULL ) ;
} // loop thru and find the element corresponding to the given key


template < class K, class V, int sz >
V&    HashTable< K, V, sz >:: operator [] ( K &kee)
{
  unsigned    index ;
  HashElement< K, V >   *elem = find(kee, index) ;

  // allocate a new element here, if required
  if ( !elem)
    {
      elem = new HashElement< K, V > (kee) ;
      table[index].queue(elem) ;
    } // allocate and queue the element

  // return a reference to the value item
  return ( elem->get_val() ) ;
} // all important operation that inserts or finds a particular value


template < class K, class V, int sz >
void HashTable< K, V, sz >::remove( K &kee)
{
  unsigned   index ;
  HashElement< K, V >   *elem = find(kee, index) ;

  // allocate a new element here, if required
  if (elem)
    {
      elem = new HashElement< K, V > (kee) ;
      table[index].remove_from_list(elem) ;
    } // make sure that the element exists

} // remove a particular element
