#ifndef lint
  static const char sccs_id[]= "%W% %G% %U%: Component-%Y% %Q%" ;
#endif

// The following few macros contain the definitions of the implementations
// of the rtti scaffoldings of template based classes. Cfront 3.0.1 does
// not generate correct code for the static initializers - but the implemen
// -tation code is generated so as not to create any problems. Hopefully,
// Cfront 3.0.2 will generate correct code for this.

TEMPL_RTTI_IMPL_SCAFF_1_1(LinkedListBase<Type>,LinkedListBase,class Type,CLASS)

TEMPL_RTTI_IMPL_SCAFF_1_1(ListSecInterface<Type>,ListSecInterface,class Type,LinkedListBase<Type>)

TEMPL_RTTI_IMPL_SCAFF_1_1(LinkedList<Type>,LinkedList,class Type,LinkedListBase<Type>)

TEMPL_RTTI_IMPL_SCAFF_1_1(ListIteratorBase<Type>,ListIteratorBase,class Type,CLASS)

TEMPL_RTTI_IMPL_SCAFF_1_1(ListIterSecIntf<Type>,ListIterSecIntf,class Type,ListIteratorBase<Type>)

TEMPL_RTTI_IMPL_SCAFF_1_1(ListIterator<Type>,ListIterator,class Type,ListIteratorBase<Type>)

// LinkedList.c - contains the definitions of the member functions that
// implements the LinkedList interface class.Essentially, it provides
// a mapping from the visible interface to the actual implementation.

// Destructor - remove the object that represents the second interface
template   <class Type>
ListIterator<Type>::~ListIterator()
{
   delete sec;
} // destructor for the Linked List interator

template   <class Type>
Type *ListIterator<Type>:: operator () ()
{
  return (sec->operator()()) ;
} // the iterator operator

template   <class Type>
void ListIterator<Type>:: reset (void)
{
  sec->reset() ;
} // the iterator operator


// ListSecInterface.c
// This file contains the defintion of the member functions that form the
// the second interface to the linked list component. In addition it also
// contains the member funtion defintions for extensions to the ImplSpec
// class (inherits from the ImplSpec class )


/*************
  Member functions for the ListSecInterface class
************/

// Constructor - get a pointer to the meta-object of the List
// implementations - then use this meta-object to instantiate
// a list with the rquired implementation.
template   <class Type>
ListSecInterface<Type>::ListSecInterface()
  : impl_type(DOUBLE), meta(0), impl(0)
{
 meta = new ListImplAncestor ;

 CLASS     *y = (*meta)->instantiate(&impl_type) ;

 impl = ListImplAncestor::_narrow(y) ;

} // constructor for Linked List interface

template   <class Type>
ListSecInterface<Type>::ListSecInterface(int value)
  : impl_type(value), meta(0), impl(0)
{
 meta = new ListImplAncestor ;
 impl = ListImplAncestor::_narrow(((*meta)->instantiate(&impl_type))) ;

} // constructor for Linked List interface

// Destructor - remove the representation and the pointer to the
// meta-object.
template   <class Type>
ListSecInterface<Type>::~ListSecInterface()
{
   delete impl ; delete meta ;
} // destructor for the Linked List interface

// This function allows for the removal of a particular item from the list.
template   <class Type>
Type *ListSecInterface<Type>::remove_from_list(Type *item)
{
 return ( (Type *)impl->remove_specific_elem((void *) item)) ;
} // remove a particular item from the list

// Merge a given list to this list
template   <class Type>
void ListSecInterface<Type>::merge_lists(LinkedListBase<Type> *list,
					    ListElemPriority  pri )
{
  impl = impl->merge_lists(list->ret_impl(), pri) ;
  delete list;
} // chain this list to the end of another list

// queue an element to the list - look up the implications of priority in
// the header file.
template   <class Type>
void ListSecInterface<Type>::queue(Type *item, ListElemPriority pri)
{
  impl->queue((void *)item,pri) ;
} // queue this element on to the list

// dequeue an element.
template   <class Type>
Type *ListSecInterface<Type>::dequeue(void)
{
  void   *ret  = impl->dequeue() ;
  return ( (Type *) ret)  ;
} // dequeue an element from the list

template   <class Type>
void ListSecInterface<Type>::set_impl(int val )
{
 if ( val != impl_type )
  {
    impl_type = val ;
    if ( impl)
       impl =
	   ListImplAncestor::_narrow(((*meta)->instantiate(&impl_type)));
  } // make sure that the type is different
} // choose an implementation

template   <class Type>
int ListSecInterface<Type>::get_impl(void )
{
    return impl_type ;
} // choose an implementation

/************************
  MEMBER FUNCTIONS FOR THE LIST ITERATOR SECOND INTERFACE
*************************/

// Constructor - get a pointer to the meta-object of the List Iterator
// implementations - then use this meta-object to instantiate
// a list with the rquired implementation.
template   <class Type>
ListIterSecIntf<Type>::ListIterSecIntf(LinkedList<Type> &x)
  : impl_type((x->get_impl()) << 2), meta(0), impl(0)
{

  meta = new ListIterAncestor ;
  ListImplAncestor *y = x.ret_impl() ;
  impl = ListIterAncestor::_narrow(((*meta)->instantiate(&impl_type,y))) ;
} // constructor for Linked List Iterator interface

template   <class Type>
ListIterSecIntf<Type>::ListIterSecIntf(LinkedList<Type> *x)
 : impl_type(((*x)->get_impl()) << 2), meta(0), impl(0)
{
  meta = new ListIterAncestor ;
  ListImplAncestor *y = (x)->ret_impl() ;
  impl = ListIterAncestor::_narrow(((*meta)->instantiate(&impl_type,y))) ;
} // constructor for Linked List Iterator interface


// Destructor - remove the representation and the pointer to the
// meta-object.
template   <class Type>
ListIterSecIntf<Type>::~ListIterSecIntf()
{
   delete impl ; delete meta ;
} // destructor for the Linked List iterator

template   <class Type>
void ListIterSecIntf<Type>::set_impl(int val )
{
     impl_type = val ;
} // choose an implementation for the implementation

template   <class Type>
Type *ListIterSecIntf<Type>::operator ()()
{
   void  *ret_ptr = impl->operator()() ;
   return ((Type *) ret_ptr )  ;
} // pass on th e function operator to the implementation

template   <class Type>
void ListIterSecIntf<Type>::reset()
{
    impl->reset()   ;
} // Pass on the function operator the implementatation




















