#ifndef lint
  static const char sccs_id[]= "%W% %G% %U%: Component-%Y% %Q%" ;
#endif

#include   "cpp_entry.h"
#include   "ListImpl.h"

/***********
 BINDINGS FOR META-OBJECTS AND SEPARATION OF INTERFACE FROM IMPLEMENTATION
***********/

// allocate an overall implementation meta-object
ListMeta *ListImplAncestor::meta = new ListMeta ;
// allocate an overall implementation meta-object
IterMeta *ListIterAncestor::meta = new IterMeta ;
RTTI_SCAFFOLDING_IMPL1(ListMeta,BaseMeta)
RTTI_SCAFFOLDING_IMPL1(IterMeta,BaseMeta)
RTTI_SCAFFOLDING_IMPL1(ListImplAncestor,CLASS)
RTTI_SCAFFOLDING_IMPL1(ListIterAncestor,CLASS)

/*************
  Member functions for the ListImpl Metaclass
************/


// Calls the instantiate function of the meta-object of the child type.
// Returns NULL if the type does not have a valid handler.
CLASS   *
ListMeta::instantiate(ImplSpec *type )
{
  return(BaseMeta::instantiate(type)) ;
} // allocate the appropriate linked list type

/*************
  Member functions for the IterImpl Metaclass
************/

// Calls the instantiate function of the meta-object of the child type.
// Returns NULL if the type does not have a valid handler.
ListIterAncestor   *
IterMeta::instantiate(ImplSpec *type, ListImplAncestor *x)
{
  impl_entry *info = find_info(type ) ;

  // check on the pointer value
  if ( info )
    {
      IterMeta *iter_info = IterMeta::_narrow(info->hdlr) ;
      return((ListIterAncestor *) iter_info->instantiate(type,x));
    } // make sure that the returned info ptr is valid

  // if we get till here - just return NULL
  return(NULL ) ;
} // allocate the appropriate linked list type

ListIterAncestor  *
IterMeta::instantiate(ImplSpec *type, ListImplAncestor &x)
{
  impl_entry *info = find_info(type ) ;

  // check on the pointer value
  if ( info )
   {
      IterMeta *iter_info = IterMeta::_narrow(info->hdlr) ;
      return((ListIterAncestor *) iter_info->instantiate(type,x));
   } // make sure that the returned info ptr is valid

  // if we get till here - just return NULL
  return(NULL ) ;
} // allocate the appropriate linked list type
