#ifndef    _H_TRACE
#define    _H_TRACE

/* %Z%%I%       %G% %U% %W% */
/*
 * COMPONENT_NAME: (COMINC) Common Header File for RTTI
 *
 * ORIGINS: 27
 *
 * (C) COPYRIGHT International Business Machines Corp. 1992
 * This work was supported by a grant from International Business
 * Machines, Inc. These procedures are contributed to the public domain
 * by International Business Machines Inc. "AS IS" without any warranty
 * of any kind including the warranty of merchantability or fitness
 * for a particular purpose.
 *
 *
 * This is free software. Feel free to redistribute and/or modify it.
 * Please send us e-mail and let us know if you have any problems
 * or suggestions.
 *
 * Arindam Banerji
 * axb@cse.nd.edu
 *
 */


#include   <iostream.h>
#include   "String.h"


// trace.hh
// This defines a simplistic trace utility.


const int  CLASSTYPE = 10 ;
const int  FUNCTIONTYPE = 11  ;


// This is the base class of the trace utility and it recognises
// only the category of the trace ie : a function trace or a
// class based trace. In addition, the scope name if relevant,
// is also stored in the common base class.
class     Trace  {
 public:
   Trace () { } ;
   Trace(string ) ;
   Trace(string ,string ) ;
   ~Trace () ;

    private:
	 string     classname ;
	 string     funcname ;
	 int        type ;
   } ;

#endif     // _H_TRACE

