/*
//	coerce.cc -- $@MM!9$J%U%)!<%^%C%H$N2hA|%U%!%$%k$rAj8_$KJQ49$9$k(J
//
//		created    in 2/11/1994
*/

#include	<stdio.h>
#include	<stdlib.h>
#include	<ctype.h>
#include	<string.h>
#include	"defs.h"
#include	"Beta.h"
#include	"Mag.h"
#include	"Maki.h"
#include	"ML1.h"
#include	"Pi.h"
#include	"Pic.h"
#include	"PPM.h"

void	Usage();
char	*ReplaceExtension( char *Original, char *Extension );

void	Usage()
{
    fputs( "coerce: a graphic format converter ver 1.00\n", stderr );
    fputs( "usage: coerce [option] [files]\n", stderr );
    fputs( "input formats:  -{mag,pi,pic,maki,ppm,pbm,ml1,beta}\n", stderr );
    fputs( "output formats: +{mag,pi,pic,ppm,beta}\n", stderr );
    fputs( "option: -notadjust -stdin -stdout -o [name] -quiet\n", stderr );
    exit (1);
}

int 	main( int argc, char *argv[] )
{
    int 	i, j;
    int 	SourceFormat, DestinationFormat;
    int 	FromStdin, ToStdout, Quiet, Infer;

    Program = argv[0];
    Initialize();
    SourceFormat = UNKNOWN;
    DestinationFormat = BETA;
    FromStdin = 0;
    ToStdout = 0;
    NoExpand = 0;
    File = NULL;
    fp = NULL;
    Quiet = 0;
    Infer = 0;
    if ( argc == 1 )
	Usage();
    for ( i = 1; i < argc; i++ ) {
	if ( *argv[i] == '-' ) {
	    if ( strcmp( argv[i], "-stdin" ) == 0 )
		FromStdin = 1;
	    else if ( strcmp( argv[i], "-stdout" ) == 0 ) {
		ToStdout = 1;
		Quiet = 1;
	    }
	    else if ( strcmp( argv[i], "-notadjust" ) == 0 )
		NoExpand = 1;
	    else if ( strcmp( argv[i], "-o" ) == 0 ) {
		ToStdout = ++i;
	    }
	    else {
		for ( j = 1; j < NumberofFormats; j++ ) 
		    if ( strcmp( argv[i] + 1, Format[j] ) == 0 )
			break;
		if ( j == NumberofFormats )
		    Usage();
		SourceFormat = j;
	    }
	}
	else if ( *argv[i] == '+' ) {
	    for ( j = 1; j < NumberofFormats; j++ )
		if ( strcmp( argv[i] + 1, Format[j] ) == 0 )
		    break;
	    if ( j == NumberofFormats )
		Usage();
	    DestinationFormat = j;
	}
	else {
	    if ( !setjmp (ErrorEntry) ) {
		if ( FromStdin )
		    error ("Input is specified doubly");
		if ( Infer )
		    SourceFormat = UNKNOWN;
		if ( SourceFormat == UNKNOWN ) {
		    SourceFormat = InferFormat (argv[i]);
		    Infer = 1;
		}
		else
		    Infer = 0;
		if ( SourceFormat == UNKNOWN )
		    error ("Source format is not specified");
		if ( !Quiet ) {
		    printf( "%s(%s) -> ", argv[i], Format[SourceFormat] );
		    fflush (stdout);
		}
		fp = NULL;
		File = argv[i];
		switch (SourceFormat) {
		    case BETA: BetaLoad(); break;
		    case MAG: MagLoad(); break;
		    case MAKI: MakiLoad(); break;
		    case ML1: ML1Load(); break;
		    case PBM: PBMLoad(); break;
		    case PI: PiLoad(); break;
		    case PIC: PicLoad(); break;
		    case PPM: PPMLoad(); break;
		    default:
			error ("Sorry, not implemented");
		}
		if ( ToStdout == 0 ) {
		    fp = NULL;
		    File = ReplaceExtension( argv[i], Extension[DestinationFormat] );
		}
		else if ( ToStdout == 1 ) {
		    fp = stdout;
		    File = "stdout";
		}
		else {
		    fp = NULL;
		    File = argv[ToStdout];
		}
		if ( !Quiet )
		    printf( "%s(%s)\n", File, Format[DestinationFormat] );
		switch (DestinationFormat) {
		    case BETA: BetaSave(); break;
		    case MAG: MagSave(); break;
		    case PI: PiSave(); break;
		    case PIC: PicSave(); break;
		    case PPM: PPMSave(); break;
		    default:
			error ("Sorry, not implemented");
		}
	    }
	}
    }
    if ( FromStdin && !setjmp (ErrorEntry) ) {
	fp = stdin;
	if ( SourceFormat == UNKNOWN )
	    error ("Source format is not specified");
	if ( ToStdout == 0 || ToStdout == 1 )
	    Quiet = 1;
	if ( !Quiet ) {
	    printf( "stdin(%s) -> ", Format[SourceFormat] );
	    fflush (stdout);
	}
	switch (SourceFormat) {
	    case BETA: BetaLoad(); break;
	    case MAG: MagLoad(); break;
	    case MAKI: MakiLoad(); break;
	    case ML1: ML1Load(); break;
	    case PBM: PBMLoad(); break;
	    case PI: PiLoad(); break;
	    case PIC: PicLoad(); break;
	    case PPM: PPMLoad(); break;
	    default:
		error ("Sorry, not implemented");
	}
	if ( ToStdout == 0 || ToStdout == 1 ) {
	    fp = stdout;
	    File = "stdout";
	}
	else {
	    fp = NULL;
	    File = argv[ToStdout];
	}
	if ( !Quiet )
	    printf( "%s(%s)\n", File, Format[DestinationFormat] );
	switch (DestinationFormat) {
	    case BETA: BetaSave(); break;
	    case MAG: MagSave(); break;
	    case PI: PiSave(); break;
	    case PIC: PicSave(); break;
	    case PPM: PPMSave(); break;
	    default:
		error ("Sorry, not implemented");
	}
    }
    return 0;
}

char	*ReplaceExtension( char *Original, char *Extension )
{
    static char	Buffer[256];
    int 	i, j;

    j = -1;
    for ( i = 0; Original[i] != '\0'; i++ )
	if ( Original[i] == DSEPARATOR )
	    j = i;
    strcpy( Buffer, Original + j + 1 );
    for ( i = strlen (Buffer) - 1; i >= 0 && Buffer[i] != '.' && Buffer[i] != DSEPARATOR; i-- );
    if ( Buffer[i] == '.' )
	Buffer[i] = '\0';
    strcat( Buffer, "." );
    strcat( Buffer, Extension );
    return Buffer;
}
