/*
//	Maki.cc -- maki$@%U%)!<%^%C%H2hA|$r07$&(J
//
//		created    in 3/7/1993
//		revised	   in 2/13/1993
*/

#include        <stdio.h>
#include        <stdlib.h>
#include        <string.h>
#include        <ctype.h>
#include	"defs.h"
#include	"Maki.h"

static unsigned char	*FlagB, *PixelData;

struct {
    int 	Type;
    char	Head[8];
    char 	Comment[24];
    int 	FlagBSize;
    int 	PixelASize;
    int 	PixelBSize;
    int 	TileSize;
    int 	Left;
    int 	Top;
    int 	Right;
    int 	Bottom;
    unsigned char	FlagA[1000];
}	MakiHeader;

void	ReadMakiHeader()
{
    int 	i;

    fread( MakiHeader.Head, 8, 1, fp );
    fread( MakiHeader.Comment, 24, 1, fp );
    MakiHeader.FlagBSize = (fgetc (fp) << 8) | fgetc (fp);
    MakiHeader.PixelASize = (fgetc (fp) << 8) | fgetc (fp);
    MakiHeader.PixelBSize = (fgetc (fp) << 8) | fgetc (fp);
    MakiHeader.TileSize = (fgetc (fp) << 8) | fgetc (fp);
    MakiHeader.Left = (fgetc (fp) << 8) | fgetc (fp);
    MakiHeader.Top = (fgetc (fp) << 8) | fgetc (fp);
    MakiHeader.Right = (fgetc (fp) << 8) | fgetc (fp);
    MakiHeader.Bottom = (fgetc (fp) << 8) | fgetc (fp);
    for ( i = 0; i < 16; i++ ) {
        Green[i] = fgetc (fp);
        Red[i] = fgetc (fp);
        Blue[i] = fgetc (fp);
	Blue[i] = ((Blue[i] >> 3) & 0x1f);
	Green[i] = ((Green[i] >> 3) & 0x1f) << 10;
	Red[i] = ((Red[i] >> 3) & 0x1f) << 5;
	Palette[i] = Red[i] | Green[i] | Blue[i];
    }
    fread( MakiHeader.FlagA, 1000, 1, fp );
}

void    ReadMakiData()
{
    if ( (FlagB = (unsigned char*)malloc (MakiHeader.FlagBSize + 16)) == NULL )
	error ("%s: Insufficient memory");
    fread( FlagB, MakiHeader.FlagBSize, 1, fp );
    if ( (PixelData = (unsigned char*)malloc (MakiHeader.PixelASize + MakiHeader.PixelBSize + 16)) == NULL )
	error ("%s: Insufficient memory");
    fread( PixelData, MakiHeader.PixelASize + MakiHeader.PixelBSize, 1, fp );
}

void	MakiLoad()
{
    if ( fp == NULL && (fp = fopen( File, "rb" )) == NULL )
	error ("%s: No such file");
    ReadMakiHeader();
    if ( strncmp( MakiHeader.Head, "MAKI01A", 7 ) == 0 )
	MakiHeader.Type = 0;
    else if ( strncmp( MakiHeader.Head, "MAKI01B", 7 ) == 0 )
	MakiHeader.Type = 1;
    else
	error ("%s: Is not maki format");
    Width = 640;
    Height = 400;
    AllocateScreen();
    ReadMakiData();
    if ( fp != stdin )
	fclose (fp);
    ExpandMakiData();
    free (FlagB);
    free (PixelData);
    MaxColorGuaranteed = 16;
}

void    ExpandMakiData()
{
    unsigned char	d1, d2;
    unsigned char	*p, *q, *r;
    int 	xor, i, j, x, y;

/*    bzero(frame_buf, 640 * 400); */
    p = MakiHeader.FlagA;
    q = FlagB;
    r = PixelData;
    for ( y = 0; y < 400; y++ )
	for ( x = 0; x < 640; x++ )
	    Screen[x + y * 640] = 0;
    for ( y = 0; y < 400; y += 4 ) {
	for ( x = 0; x < 640; x += 64 ) {
	    d1 = *p++;
	    for ( i = 0; i < 8; i++ ) {
		if (d1 & 0x80) {
		    d2 = *q++;
		    for ( j = 0; j < 4; j++ ) {
			if (d2 & 0x80)
			    Screen[y * 640 + x + 8*i + 2*j] = 1;
			d2 <<= 1;
		    }
		    for (j = 4; j < 8; j++) {
			if (d2 & 0x80)
			    Screen[(y + 1) * 640 + x + 8*i + 2*(j - 4)] = 1;
			d2 <<= 1;
		    }
		    d2 = *q++;
		    for (j = 0; j < 4; j++) {
			if (d2 & 0x80)
			    Screen[(y + 2) * 640 + x + 8*i + 2*j] = 1;
			d2 <<= 1;
		    }
		    for (j = 4; j < 8; j++) {
			if (d2 & 0x80)
			    Screen[(y + 3) * 640 + x + 8*i + 2*(j - 4)] = 1;
			d2 <<= 1;
		    }
		}
		d1 <<= 1;	
	    }	
	}
    }
    for ( y = 0; y < 400; y++ ) {
	for ( x = 0; x < 640; x += 2 ) {
	    if ( Screen[y * 640 + x] ) {
		Screen[y * 640 + x] = *r >> 4;;
	        Screen[y * 640 + x + 1] = *r & 0xf;
		r++;
	    }
	}
    }
    if ( MakiHeader.Type == 0 )
	xor = 2;
    else
	xor = 4;
    i = 0;
    j = xor * 640;
    for ( y = xor; y < 400; y++ ) {
	for ( x = 0; x < 640; x++ ) {
	    Screen[j++] ^= Screen[i++];
	}
    }
    i = 0;
    for ( y = 0; y < 400; y++ ) {
	for ( x = 0; x < 640; x++ ) {
	    Screen[i] = Palette[Screen[i]];
	    i++;
	}
    }
}
