/*
//	mkmains.cc -- $@AH9g$;$r@8@.$9$k(J
//
//		created    in 2/11/1994
*/

#include	<stdio.h>
#include	<stdlib.h>
#include	<ctype.h>
#include	<string.h>

#define	PIC	0
#define	MAG	1
#define	MAKI	2
#define	PI	3
#define	ML1	4
#define	PPM	5
#define	PBM	6
#define	NumberofFormats	7

int	Loader[] = { PIC, MAG, MAKI, PI, ML1, PPM, PBM, -1 };
int 	Saver[] = { PIC, MAG, PI, PPM, -1 };
char	*Format[NumberofFormats];
char	*Header[NumberofFormats];
char	*Function[NumberofFormats];
char	*Program;

void	error( char *Message, char *Argument );
void	Generate( int LoadFormat, int SaveFormat );
void	GeneratePic( int LoadFormat, int SaveFormat );

int 	main( int argc, char *argv[] )
{
    int 	i, j;
    FILE	*fp;

    Program = argv[0];
    Format[PIC] = "pic"; Format[MAG] = "mag"; Format[MAKI] = "maki";
    Format[PI] = "pi"; Format[ML1] = "ml1"; Format[PPM] = "ppm";
    Format[PBM] = "pbm";
    Header[PIC] = "Pic.h"; Header[MAG] = "Mag.h"; Header[MAKI] = "Maki.h";
    Header[PI] = "Pi.h"; Header[ML1] = "ML1.h"; Header[PPM] = "PPM.h";
    Header[PBM] = "PPM.h";
    Function[PIC] = "Pic"; Function[MAG] = "Mag"; Function[MAKI] = "Maki";
    Function[PI] = "Pi"; Function[ML1] = "ML1"; Function[PPM] = "PPM";
    Function[PBM] = "PBM";
    if ( (fp = fopen( "Makefile.each", "wb" )) == NULL )
	error( "Makefile.each: Cannot create", NULL );
    fputs( "all :", fp );
    for ( i = 0; Loader[i] != -1; i++ ) {
	for ( j = 0; Saver[j] != -1; j++ ) {
	    if ( Loader[i] == Saver[j] )
		continue;
	    if ( Loader[i] == PBM && Saver[j] == PPM )
		continue;
	    if ( Loader[i] == PPM && Saver[j] == PBM )
		continue;
	    fprintf( fp, " %sto%s", Format[Loader[i]], Format[Saver[j]] );
	}
    }
    fputc( '\n', fp );
    for ( i = 0; Loader[i] != -1; i++ ) {
	for ( j = 0; Saver[j] != -1; j++ ) {
	    if ( Loader[i] == Saver[j] )
		continue;
	    if ( Loader[i] == PBM && Saver[j] == PPM )
		continue;
	    if ( Loader[i] == PPM && Saver[j] == PBM )
		continue;
	    if ( Loader[i] == PIC || Saver[j] == PIC )
		GeneratePic( Loader[i], Saver[j] );
	    else
		Generate( Loader[i], Saver[j] );
	    fprintf( fp, "%sto%s : %sto%s.c coerce.a\n",
		     Format[Loader[i]], Format[Saver[j]],
		     Format[Loader[i]], Format[Saver[j]] );
	    fprintf( fp, "\t$(CC) -o $@ -O %sto%s.c coerce.a\n",
		     Format[Loader[i]], Format[Saver[j]] );
	}
    }
    fclose (fp);
    return 0;
}

void	Generate( int LoadFormat, int SaveFormat )
{
    FILE	*fp;
    char	File[128];

    sprintf( File, "%sto%s.c", Format[LoadFormat], Format[SaveFormat] );
    if ( (fp = fopen( File, "wb" )) == NULL )
	error( "%s: Cannot create", File );
    fputs( "#include\t<stdio.h>\n", fp );
    fputs( "#include\t<stdlib.h>\n", fp );
    fprintf( fp, "#include\t\"defs.h\"\n" );
    fprintf( fp, "#include\t\"%s\"\n", Header[LoadFormat] );
    fprintf( fp, "#include\t\"%s\"\n", Header[SaveFormat] );
    fputs( "\nvoid\tUsage();\n\n", fp );
    fputs( "int\tmain( int argc, char *argv[] )\n{\n", fp );
    fputs( "    Program = argv[0];\n    if ( argc > 2 )\n", fp );
    fputs( "\tUsage();\n    else if ( argc != 1 ) {\n	fp = NULL;\n", fp );
    fputs( "\tFile = argv[1];\n    }\n    else {\n\tfp = stdin;\n", fp );
    fputs( "\tFile = \"stdin\";\n    }\n    if ( !setjmp (ErrorEntry) ) {\n", fp );
    fprintf( fp, "\t%sLoad();\n", Function[LoadFormat] );
    fputs( "\tfp = stdout;\n\tFile = \"stdout\";\n", fp );
    fprintf( fp, "\t%sSave();\n", Function[SaveFormat] );
    fputs( "    }\n    return 0;\n}\n\n", fp );
    fputs( "void\tUsage()\n{\n", fp );
    fputs( "    fprintf( stderr, \"usage: %s ([file])\\n\", Program );\n", fp );
    fputs( "    exit (1);\n}\n", fp );
    fclose (fp);
}

void	GeneratePic( int LoadFormat, int SaveFormat )
{
    FILE	*fp;
    char	File[128];

    sprintf( File, "%sto%s.c", Format[LoadFormat], Format[SaveFormat] );
    if ( (fp = fopen( File, "wb" )) == NULL )
	error( "%s: Cannot create", File );
    fputs( "#include\t<stdio.h>\n", fp );
    fputs( "#include\t<stdlib.h>\n", fp );
    fputs( "#include\t<string.h>\n", fp );
    fprintf( fp, "#include\t\"defs.h\"\n" );
    fprintf( fp, "#include\t\"%s\"\n", Header[LoadFormat] );
    fprintf( fp, "#include\t\"%s\"\n", Header[SaveFormat] );
    fputs( "\nvoid\tUsage();\n\n", fp );
    fputs( "int\tmain( int argc, char *argv[] )\n{\n    int\ti;\n\n", fp );
    fputs( "Program = argv[0];\n    NoExpand = 0;\n    File = NULL;\n", fp );
    fputs ("    for ( i = 1; i < argc; i++ ) {\n", fp );
    fputs( "\tif ( strcmp( argv[i], \"-notadjust\" ) == 0 )\n", fp );
    fputs( "\t    NoExpand = 1;\n", fp );
    fputs( "\telse if ( *argv[i] == '-' )\n\t    Usage();\n", fp );
    fputs( "\telse if ( File == NULL )\n\t    File = argv[i];\n", fp );
    fputs( "\telse\n\t    Usage();\n    }\n", fp );
    fputs( "    if ( File == NULL ) {\n\tfp = stdin;\n\tFile = \"stdin\";\n", fp );
    fputs( "    }\n    if ( !setjmp (ErrorEntry) ) {\n", fp );
    fprintf( fp, "\t%sLoad();\n", Function[LoadFormat] );
    fputs( "\tfp = stdout;\n\tFile = \"stdout\";\n", fp );
    fprintf( fp, "\t%sSave();\n", Function[SaveFormat] );
    fputs( "    }\n    return 0;\n}\n\n", fp );
    fputs( "void\tUsage()\n{\n", fp );
    fputs( "    fprintf( stderr, \"usage: %s [-notadjust] ([file])\\n\", Program );\n", fp );
    fputs( "    exit (1);\n}\n", fp );
    fclose (fp);
}

void	error( char *Message, char *Argument )
{
    fputs( Program, stderr );
    fputs( ": ", stderr );
    fprintf( stderr, Message, Argument );
    fputc( '\n', stderr );
    exit (1);
}
