/*
//	PPM.cc -- ppm,pgm$@%U%)!<%^%C%H2hA|$r07$&(J
//
//		created    in 3/22/1993
//		revised    in 2/12/1994
*/

#include	<stdio.h>
#include	<stdlib.h>
#include	<ctype.h>
#include	"defs.h"
#include	"PPM.h"

void	SkipSpace()
{
    int 	c;

    for ( ;; ) {
	if ( (c = fgetc (fp)) != ' ' && c != '\t' && c != '\n' && c != '\r' && c != '#' ) {
	    ungetc( c, fp );
	    return;
	}
	if ( c == '#' ) {
	    for ( ;; ) {
		if ( (c = fgetc (fp)) == '\n' || c == EOF )
		    break;
	    }
	}
    }
}

int 	GetInteger()
{
    int 	c, Value;

    SkipSpace();
    Value = 0;
    for ( ;; ) {
	if ( !isdigit (c = fgetc (fp)) )
	    return Value;
	Value = Value * 10 + c - '0';
    }
}

void	PPMLoad()
{
    int 	c, MaxColor, i, HalfSize;
    int		r, g, b;

    if ( fp == NULL && (fp = fopen( File, "rb" )) == NULL )
	error ("%s: No such file");
    if ( fgetc (fp) != 'P' )
	error ("%s: Is not ppm format");
    if ( (c = fgetc (fp)) != '3' && c != '6' )
	error ("%s: Is not ppm format");
    Width = GetInteger();
    Height = GetInteger();
    MaxColor = GetInteger();
    AllocateScreen();
    MaxColor++;
    HalfSize = Size / 2;
    if ( c == '3' ) {
	for ( i = 0; i < HalfSize; i++ ) {
	    r = ((GetInteger()) * 32) / MaxColor;
	    g = ((GetInteger()) * 32) / MaxColor;
	    b = ((GetInteger()) * 32) / MaxColor;
	    Screen[i] = (r << 5) | (g << 10) | b;
	}
    }
    else {
	for ( i = 0; i < HalfSize; i++ ) {
	    r = fgetc (fp);
	    g = fgetc (fp);
	    b = fgetc (fp);
	    r = ((r * 32) / MaxColor) & 31;
	    g = ((g * 32) / MaxColor) & 31;
	    b = ((b * 32) / MaxColor) & 31;
	    Screen[i] = (r << 5) | (g << 10) | b;
	}
    }
    if ( fp != stdin )
	fclose (fp);
    MaxColorGuaranteed = 32768;
}

void	PPMSave()
{
    int 	r, g, b, HalfSize, i;

    if ( fp == NULL && (fp = fopen( File, "wb" )) == NULL )
	error ("%s: Cannot create");
    fprintf( fp, "P6\n%d %d\n255\n", Width, Height );
    HalfSize = Width * Height;
    for ( i = 0; i < HalfSize; i++ ) {
	r = (Screen[i] >> 5) & 31;
	g = (Screen[i] >> 10) & 31;
	b = Screen[i] & 31;
	fputc( r << 3, fp );
	fputc( g << 3, fp );
	fputc( b << 3, fp );
    }
    if ( fp != stdout )
	fclose (fp);
}

void	PBMLoad()
{
    int 	c, i, HalfSize, x, y;

    if ( fp == NULL && (fp = fopen( File, "rb" )) == NULL )
	error ("%s: No such file");
    if ( fgetc (fp) != 'P' )
	error ("%s: Is not pbm format");
    if ( (c = fgetc (fp)) != '1' && c != '4' )
	error ("%s: Is not pbm format");
    Width = GetInteger();
    Height = GetInteger();
    AllocateScreen();
    HalfSize = Size / 2;
    if ( c == '1' ) {
	for ( i = 0; i < HalfSize; i++ ) {
	    if ( GetInteger() != 0 ) 
		Screen[i] = 0;
	    else
		Screen[i] = 0x7fff;
	}
    }
    else {
	for ( y = 0; y < Height; y++ ) {
	    for ( x = 0; x < Width; x += 8 ) {
		c = fgetc (fp);
		for ( i = 0; i < 8; i++ ) {
		    if ( BitField[i] & c )
			Screen[x + i + y * Width] = 0;
		    else
			Screen[x + i + y * Width] = 0x7fff;
		}
	    }
	}
    }
    if ( fp != stdin )
	fclose (fp);
    MaxColorGuaranteed = 2;
}
