//*BHEADER* :ts=8  -*- C++ -*-
/*****************************************************************************
 *
 *   |_|_|_  |_|_    |_    |_|_|_  |_		     C O M M U N I C A T I O N
 * |_        |_  |_  |_  |_        |_		               N E T W O R K S
 * |_        |_  |_  |_  |_        |_		                     C L A S S
 *   |_|_|_  |_    |_|_    |_|_|_  |_|_|_|_	                 L I B R A R Y
 *
 * $Id: IntAVLNode.c,v 1.1 1995/08/09 17:16:34 steppler Exp $
 *
 * Class: IntAVLNode --- example using CNAVLNode
 *
 *****************************************************************************
 * Copyright (C) 1992-1995   Communication Networks
 *                           Aachen University of Technology
 *                           D-52056 Aachen
 *                           Germany
 *                           Email: cncl-adm@dfv.rwth-aachen.de
 *****************************************************************************
 * This file is part of the CN class library. All files marked with
 * this header are free software; you can redistribute it and/or modify
 * it under the terms of the GNU Library General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.  This library is
 * distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library General Public
 * License for more details.  You should have received a copy of the GNU
 * Library General Public License along with this library; if not, write
 * to the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 * 
 * As an exception to this rule you may use this template to generate
 * your own classes. This does not cause these classes to be covered by
 * the GNU Library General Public License. This exception does not
 * however invalidate any other reasons why the resulting program must be
 * covered by the GNU Library General Public License.
 **EHEADER********************************************************************/

#include "IntAVLNode.h"
#include "IntAVLTree.h"


int IntAVLNode::compare(CNAVLNode *n) {
    long c = IntAVLNode::cast_from_object(n)->key_;
    if (key_ < c) return -1;
    if (key_ > c) return  1;
    return 0;
};
int IntAVLNode::find(CNAVLTree *t) {
    long c = IntAVLTree::cast_from_object(t)->searchkey;
    if (key_ < c) return -1;
    if (key_ > c) return  1;
    return 0;
};

/***** Default I/O member function for CNCL classes **************************/

// Normal output
void IntAVLNode::print(ostream &strm) const
{
    strm << "key=" << key_ << endl;
}

// Debug output
void IntAVLNode::dump(ostream &strm) const
{
    strm << "IntAVLNode { $Revision: 1.1 $ " << endl;
    CNAVLNode::dump(strm);
    strm << "key=" << key_ << " }" << endl;
}



/***** CNCL stuff for type information ***************************************/

// Describing object for class IntAVLNode
static CNClass IntAVLNode_desc("IntAVLNode", "$Revision: 1.1 $",
			    IntAVLNode::new_object);

// "Type" for type checking functions
CNClassDesc CN_INTAVLNODE = &IntAVLNode_desc;
