//*BHEADER* :ts=8  -*- C++ -*-
/*****************************************************************************
 *
 *   |_|_|_  |_|_    |_    |_|_|_  |_		     C O M M U N I C A T I O N
 * |_        |_  |_  |_  |_        |_		               N E T W O R K S
 * |_        |_  |_  |_  |_        |_		                     C L A S S
 *   |_|_|_  |_    |_|_    |_|_|_  |_|_|_|_	                 L I B R A R Y
 *
 * $Id: EZDServer.c,v 0.29 1995/07/05 12:48:24 cncl-adm Exp $
 *
 * Class: EZDServer --- Graphical representation of a server
 *
 *****************************************************************************
 * Copyright (C) 1992-1995   Communication Networks
 *                           Aachen University of Technology
 *                           D-52056 Aachen
 *                           Germany
 *                           Email: cncl-adm@dfv.rwth-aachen.de
 *****************************************************************************
 * This file is part of the CN class library. All files marked with
 * this header are free software; you can redistribute it and/or modify
 * it under the terms of the GNU Library General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.  This library is
 * distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library General Public
 * License for more details.  You should have received a copy of the GNU
 * Library General Public License along with this library; if not, write
 * to the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 **EHEADER********************************************************************/

#include "EZDServer.h"



/*
 * Initialize coordinates
 */
void EZDServer::initialize(int radius)
{
    rad = radius;
}



/*
 * Draw server as filled arc
 */
void EZDServer::redraw()
{
    start();
    fill_arc(0, -rad, rad*2, rad*2, 0, 360, col);
    arc(0, -rad, rad*2, rad*2, 0, 360, "");
    end();
    EZD::pause(1);
}



/***** Default I/O member function for CNCL classes **************************/

// Normal output
void EZDServer::print(ostream &strm) const
{
    // ... insert your own stuff here ...
    strm << "..." << endl;
}

// Debug output
void EZDServer::dump(ostream &strm) const
{
    // ... insert your own stuff here ...
    strm << "EZDServer { $Revision: 0.29 $"
	 << " }" << endl;
}



/***** CNCL stuff for type information ***************************************/

// Describing object for class EZDServer
static CNClass EZDServer_desc("EZDServer", "$Revision: 0.29 $",
			      EZDServer::new_object);

// "Type" for type checking functions
CNClassDesc CN_EZDSERVER = &EZDServer_desc;






