//*BHEADER* :ts=8  -*- C++ -*-
/*****************************************************************************
 *
 *   |_|_|_  |_|_    |_    |_|_|_  |_		     C O M M U N I C A T I O N
 * |_        |_  |_  |_  |_        |_		               N E T W O R K S
 * |_        |_  |_  |_  |_        |_		                     C L A S S
 *   |_|_|_  |_    |_|_    |_|_|_  |_|_|_|_	                 L I B R A R Y
 *
 * $Id: Piostream.c,v 0.29 1995/07/05 12:48:16 cncl-adm Exp $
 *
 * Class: CNPiostream --- persistent iostream format
 *
 *****************************************************************************
 * Copyright (C) 1992-1995   Communication Networks
 *                           Aachen University of Technology
 *                           D-52056 Aachen
 *                           Germany
 *                           Email: cncl-adm@dfv.rwth-aachen.de
 *****************************************************************************
 * This file is part of the CN class library. All files marked with
 * this header are free software; you can redistribute it and/or modify
 * it under the terms of the GNU Library General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.  This library is
 * distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library General Public
 * License for more details.  You should have received a copy of the GNU
 * Library General Public License along with this library; if not, write
 * to the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 **EHEADER********************************************************************/

#include <CNCL/String.h>
#include "Piostream.h"

CNPstream& CNPiostream::operator<<(const char* val){
   *strm << val << endl; return *this;
}

CNPstream& CNPiostream::operator<<(char val){
   *strm << val << endl; return *this;
}

CNPstream& CNPiostream::operator<<(long val){
   *strm << val << endl; return *this;
}

CNPstream& CNPiostream::operator<<(double val){
   *strm << val << endl; return *this;
}

CNPstream& CNPiostream::operator>>(char* val){

    *strm >> val;
    return *this;
}

CNPstream& CNPiostream::operator>>(char& val){
   *strm >> val; return *this;
}

CNPstream& CNPiostream::operator>>(long& val){
   *strm >> val; return *this;
}

CNPstream& CNPiostream::operator>>(double& val){
   *strm >> val; return *this;
}

CNPstream& CNPiostream::getline(char* cs, int len)
{
    strm->getline(cs, len);
    return *this;
}

/***** CNCL stuff for type information ***************************************/

// Describing object for class CNPiostream
static CNClass CNPiostream_desc("CNPiostream", "$Revision: 0.29 $",
			   NIL );

// "Type" for type checking functions
CNClassDesc CN_PIOSTREAM = &CNPiostream_desc;

